/*
 * User Mode Sandbox for Grid
 * Copyright (C) 2004 Tangui Morlier
 * Copyright (C) 2004 Grand-Large (INRIA Futurs)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#ifndef FORK_FUNCTIONS_H
#define FORK_FUNCTIONS_H
#include <signal.h>
#include "common.h"
#include "sandboxRules.h" 

/*****************************************************************
 * Here are defined the filters for forks and signals operations *
 *****************************************************************/

/**
 * Register the new process
 */
int fork_attitude(struct ptrace_info_struct * pi, char* ptr, char* msg);

/**
 * Only are allowed to send a signal on sandboxed application processes
 */
int kill_attitude(struct ptrace_info_struct * pi, char* ptr, char* msg);

/**
 * The modification of signal behavious is not allowed on SIGTRAP
 */
int signals_filter(struct ptrace_info_struct * pi, char* ptr, char* msg);
int sigset_filter(struct ptrace_info_struct * pi, char* ptr, char* msg);

/**
 * Decode a sigset like calls
 */
void sigset_decoder (struct ptrace_info_struct * pi, void * decoded);
/**
 * Decode the sigprocmask calls
 */
void sigprocmask_decoder (struct ptrace_info_struct * pi, void * decoded);
/**
 * Decode the sigaction calls
 */
void sigaction_decoder (struct ptrace_info_struct * pi, void * decoded);
#endif // FORK_FUNCTIONS_H
